From 0be49b12c6253f9a2a574893363e7ad5634396f0 Mon Sep 17 00:00:00 2001
From: Philip Cali <philip.cali@gmail.com>
Date: Mon, 13 Feb 2012 14:12:21 -0600
Subject: Curve-to system wide setting

---
 admin/settings/grades.php     |    4 ++++
 grade/edit/tree/index.php     |    7 +++++++
 grade/edit/tree/item.php      |   23 ++++++++++++++++++++++-
 grade/edit/tree/item_form.php |   22 ++++++++++++++++++++--
 grade/edit/tree/lib.php       |   20 ++++++++++++++++++--
 lang/en/grades.php            |    4 ++++
 6 files changed, 75 insertions(+), 5 deletions(-)

diff --git a/admin/settings/grades.php b/admin/settings/grades.php
index 0d42537..8fe5ebf 100644
--- a/admin/settings/grades.php
+++ b/admin/settings/grades.php
@@ -122,6 +122,10 @@ if (has_capability('moodle/grade:manage', $systemcontext)
     /// Grade item settings
     $temp = new admin_settingpage('gradeitemsettings', get_string('gradeitemsettings', 'grades'), 'moodle/grade:manage');
     if ($ADMIN->fulltree) {
+        $temp->add(new admin_setting_configcheckbox('grade_multfactor_alt',
+            get_string('multfactor_alt', 'grades'),
+            get_string('multfactor_alt_desc', 'grades'), 0));
+
         $temp->add(new admin_setting_configselect('grade_displaytype', get_string('gradedisplaytype', 'grades'),
                                                   get_string('gradedisplaytype_help', 'grades'), GRADE_DISPLAY_TYPE_REAL, $display_types));
 
diff --git a/grade/edit/tree/index.php b/grade/edit/tree/index.php
index 8d88615..4b39d25 100644
--- a/grade/edit/tree/index.php
+++ b/grade/edit/tree/index.php
@@ -234,6 +234,8 @@ if ($current_view != '') {
 //Ideally we could do the updates through $grade_edit_tree to avoid recreating it
 $recreatetree = false;
 
+$curve_to = get_config('moodle', 'grade_multfactor_alt');
+
 if ($data = data_submitted() and confirm_sesskey()) {
     // Perform bulk actions first
     if (!empty($data->bulkmove)) {
@@ -277,10 +279,15 @@ if ($data = data_submitted() and confirm_sesskey()) {
 
             $grade_item = grade_item::fetch(array('id'=>$aid, 'courseid'=>$courseid));
 
+            if ($param === 'multfactor' and $curve_to) {
+                $value = $value / $grade_item->grademax;
+            }
+
             if ($param === 'grademax' and $value < $grade_item->grademin) {
                 // better not allow values lower than grade min
                 $value = $grade_item->grademin;
             }
+
             $grade_item->$param = $value;
 
             $grade_item->update();
diff --git a/grade/edit/tree/item.php b/grade/edit/tree/item.php
index 1ce936c..6fad7c5 100644
--- a/grade/edit/tree/item.php
+++ b/grade/edit/tree/item.php
@@ -44,6 +44,8 @@ $returnurl = $gpr->get_return_url('index.php?id='.$course->id);
 
 $heading = get_string('itemsedit', 'grades');
 
+$curve_to = get_config('moodle', 'grade_multfactor_alt');
+
 if ($grade_item = grade_item::fetch(array('id'=>$id, 'courseid'=>$courseid))) {
     // redirect if outcomeid present
     if (!empty($grade_item->outcomeid) && !empty($CFG->enableoutcomes)) {
@@ -78,10 +80,18 @@ if ($item->hidden > 1) {
 
 $item->locked = !empty($item->locked);
 
+$multfactor = $item->multfactor;
+$curve_decimals = 4;
+
+if ($curve_to) {
+    $curve_decimals = $decimalpoints;
+    $multfactor *= $item->grademax;
+}
+
 $item->grademax        = format_float($item->grademax, $decimalpoints);
 $item->grademin        = format_float($item->grademin, $decimalpoints);
 $item->gradepass       = format_float($item->gradepass, $decimalpoints);
-$item->multfactor      = format_float($item->multfactor, 4);
+$item->multfactor      = format_float($multfactor, $curve_decimals);
 $item->plusfactor      = format_float($item->plusfactor, 4);
 
 if ($parent_category->aggregation == GRADE_AGGREGATE_SUM or $parent_category->aggregation == GRADE_AGGREGATE_WEIGHTED_MEAN2) {
@@ -130,6 +140,17 @@ if ($mform->is_cancelled()) {
         }
     }
 
+    // Special handling of curve to
+    if ($curve_to) {
+        if (empty($data->multfactor) || $data->multfactor <= 0.0000) {
+            $data->multfactor = 1.0000;
+        } else if (!isset($data->curve_to) and isset($item->multfactor)) {
+            $data->multfactor = $grade_item->multfactor;
+        } else {
+            $data->multfactor = $data->multfactor / $data->grademax;
+        }
+    }
+
     $grade_item = new grade_item(array('id'=>$id, 'courseid'=>$courseid));
     grade_item::set_properties($grade_item, $data);
     $grade_item->outcomeid = null;
diff --git a/grade/edit/tree/item_form.php b/grade/edit/tree/item_form.php
index 642be6b..e16fa42 100644
--- a/grade/edit/tree/item_form.php
+++ b/grade/edit/tree/item_form.php
@@ -88,8 +88,26 @@ class edit_item_form extends moodleform {
         $mform->disabledIf('gradepass', 'gradetype', 'eq', GRADE_TYPE_NONE);
         $mform->disabledIf('gradepass', 'gradetype', 'eq', GRADE_TYPE_TEXT);
 
-        $mform->addElement('text', 'multfactor', get_string('multfactor', 'grades'));
-        $mform->addHelpButton('multfactor', 'multfactor', 'grades');
+        if (get_config('moodle', 'grade_multfactor_alt')) {
+            $curve_to = get_string('multfactor_alt', 'grades');
+            $perform_curve = get_string('allow_multfactor_alt', 'grades');
+
+            $mform->addElement('checkbox', 'curve_to', $perform_curve,'');
+
+            $mform->setAdvanced('curve_to');
+
+            $mform->addElement('text', 'multfactor', $curve_to);
+
+            $mform->disabledIf('curve_to', 'gradetype', 'eq', GRADE_TYPE_NONE);
+            $mform->disabledIf('curve_to', 'gradetype', 'eq', GRADE_TYPE_TEXT);
+
+            $mform->disabledIf('multfactor', 'curve_to', 'notchecked');
+            $mform->addHelpButton('multfactor', 'multfactor_alt', 'grades', null);
+        } else {
+            $mform->addElement('text', 'multfactor', get_string('multfactor', 'grades'));
+            $mform->addHelpButton('multfactor', 'multfactor', 'grades');
+        }
+
         $mform->setAdvanced('multfactor');
         $mform->disabledIf('multfactor', 'gradetype', 'eq', GRADE_TYPE_NONE);
         $mform->disabledIf('multfactor', 'gradetype', 'eq', GRADE_TYPE_TEXT);
diff --git a/grade/edit/tree/lib.php b/grade/edit/tree/lib.php
index 49af487..8d44a53 100644
--- a/grade/edit/tree/lib.php
+++ b/grade/edit/tree/lib.php
@@ -1009,15 +1009,20 @@ class grade_edit_tree_column_keephigh extends grade_edit_tree_column_category {
 }
 
 class grade_edit_tree_column_multfactor extends grade_edit_tree_column {
+    private $curve_to;
 
     public function __construct($params) {
+        $this->curve_to = get_config('moodle', 'grade_multfactor_alt');
         parent::__construct();
     }
 
     public function get_header_cell() {
         global $OUTPUT;
         $headercell = clone($this->headercell);
-        $headercell->text = get_string('multfactor', 'grades').$OUTPUT->help_icon('multfactor', 'grades');
+
+        $name = $this->curve_to ? 'multfactor_alt' : 'multfactor';
+
+        $headercell->text = get_string($name, 'grades').$OUTPUT->help_icon($name, 'grades');
         return $headercell;
     }
 
@@ -1037,7 +1042,18 @@ class grade_edit_tree_column_multfactor extends grade_edit_tree_column {
             return $itemcell;
         }
 
-        $multfactor = '<input type="text" size="4" id="multfactor'.$item->id.'" name="multfactor_'.$item->id.'" value="'.grade_edit_tree::format_number($item->multfactor).'" />';
+        $size = 4;
+        $multfactor = $item->multfactor;
+
+        if ($this->curve_to) {
+            $decimals = $item->get_decimals();
+            $size += $decimals;
+            $multfactor = format_float(($multfactor * $item->grademax), $decimals);
+        } else {
+            $multfactor = grade_edit_tree::format_number($multfactor);
+        }
+
+        $multfactor = '<input type="text" size="'.$size.'" id="multfactor'.$item->id.'" name="multfactor_'.$item->id.'" value="'.$multfactor.'" />';
 
         $itemcell->text = $multfactor;
         return $itemcell;
diff --git a/lang/en/grades.php b/lang/en/grades.php
index b583eff..3505c4d 100644
--- a/lang/en/grades.php
+++ b/lang/en/grades.php
@@ -401,6 +401,10 @@ $string['moveselectedto'] = 'Move selected items to';
 $string['movingelement'] = 'Moving {$a}';
 $string['multfactor'] = 'Multiplicator';
 $string['multfactor_help'] = 'The multiplicator is the factor by which all grades for this grade item will be multiplied, with a maximum value of the maximum grade. For example, if the multiplicator is 2 and the maximum grade is 100, then all grades less than 50 are multiplied by 2, and all grades 50 and above are changed to 100.';
+$string['allow_multfactor_alt'] = 'Perform Curve To';
+$string['multfactor_alt'] = 'Curve To';
+$string['multfactor_alt_desc'] = 'Curve To will replace the Multiplicator element on the grade item edit form. Users will instead enter a value to _Curve To_ and the Multiplicator is applied under the covers.';
+$string['multfactor_alt_help'] = 'The curve to is the value by which all the grades for this grade item will be adjusted. For example, if the curve-to is 200, and the maximum grade is 100, then all grades are adjusted by multiplying all the grades by 2.';
 $string['mypreferences'] = 'My preferences';
 $string['myreportpreferences'] = 'My report preferences';
 $string['navmethod'] = 'Navigation method';
-- 
1.7.1


